let type unit = tt_C  
in
let type bool = true_C + false_C  
in
let type nat = O_C + S_C nat  
in
let type sum *A *B = inl_C *A + inr_C *B  
in
let type prod *A *B = pair_C *A *B  
in
let type sig *A = exist_C *A  
in
let type sig2 *A = exist2_C *A  
in
let type sigS *A *P = existS_C *A *P  
in
let type sigS2 *A *P *Q = existS2_C *A *P *Q  
in
let type sumbool = left_C + right_C  
in
let type sumor *A = inleft_C *A + inright_C  
in
let type connected *A = R_connected_C + Eq_connected_C + L_connected_C  
in
let type M = A0_C + A1_C  
in
let type word = Emptyword_C + Cons_C M word  
in
let type bad *A *f =
bad_intro_C
    ((nat->(word->*f->*A)->*A) ) ((nat->word->word->*f->*f->*A->*A)
                                      ) ((nat->
                                           nat->word->word->*f->*f->*A)
                                        ) 
in
let type Xn *f =
Xa_intro_C nat word *f + X'_intro_C nat nat (Xn *f) nat (Xn *f)  
in
let type Leastp *X *A = Leastp_intro_C *X (nat->*X->*A)  
in
let type fx *A *f =
fxhd_C *f + fxtl_C nat ((Leastp *A (Xn *f))) *f  
in
let type f = f_intro_C  
in
let type A = A_intro_C nat nat  
in
let tt = tt_C

in
let unit_rec f u =
 let rec VAR1 = (\VAR2.(case VAR2 in   tt_C :  f
                                     end )) in (VAR1 u)

in
let true_ren = true_C

in
let false_ren = false_C

in
let bool_rec f f0 b =
 let rec VAR1 = (\VAR2.(case VAR2 in   true_C :  f
                                     ||false_C :  f0
                                     end ))
   in (VAR1 b)

in
let O = O_C

in
let S Var1 = (S_C Var1)

in
let nat_rec f f0 n =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in
       O_C :  f
     ||(S_C VAR3) :  ((\fi.\F.\y.(fi y (F y))) f0 VAR1 VAR3)
     end
    ))
   in (VAR1 n)

in
let inl Var1 = (inl_C Var1)

in
let inr Var1 = (inr_C Var1)

in
let sum_rec f f0 s =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in
       (inl_C VAR3) :  (f VAR3)
     ||(inr_C VAR4) :  (f0 VAR4)
     end
    ))
   in (VAR1 s)

in
let pair Var1 Var2 = (pair_C Var1 Var2)

in
let prod_rec f p =
 let rec VAR1 = 
  (\VAR2.(case VAR2 in   (pair_C VAR3 VAR4) :  (f VAR3 VAR4)
                       end ))
   in (VAR1 p)

in
let fst_ren u =
 ((\f.
    let rec VAR1 = 
     (\VAR2.(case VAR2 in   (pair_C VAR3 VAR4) :  (f VAR3 VAR4)
                          end ))
      in (VAR1 u))
   (\y.\z.y)
 )

in
let snd u =
 ((\f.
    let rec VAR1 = 
     (\VAR2.(case VAR2 in   (pair_C VAR3 VAR4) :  (f VAR3 VAR4)
                          end ))
      in (VAR1 u))
   (\y.\z.z)
 )

in
let exist Var1 = (exist_C Var1)

in
let sig_rec f s =
 let rec VAR1 = (\VAR2.(case VAR2 in   (exist_C VAR3) :  (f VAR3)
                                     end ))
   in (VAR1 s)

in
let exist2 Var1 = (exist2_C Var1)

in
let sig2_rec f s =
 let rec VAR1 = 
  (\VAR2.(case VAR2 in   (exist2_C VAR3) :  (f VAR3)
                       end ))
   in (VAR1 s)

in
let existS Var1 Var2 = (existS_C Var1 Var2)

in
let sigS_rec f s =
 let rec VAR1 = 
  (\VAR2.(case VAR2 in   (existS_C VAR3 VAR4) :  (f VAR3 VAR4)
                       end ))
   in (VAR1 s)

in
let existS2 Var1 Var2 Var3 = (existS2_C Var1 Var2 Var3)

in
let sigS2_rec f s =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in   (existS2_C VAR3 VAR4 VAR5) :  (f VAR3 VAR4 VAR5)
                  end
    ))
   in (VAR1 s)

in
let left = left_C

in
let right = right_C

in
let sumbool_rec f f0 s =
 let rec VAR1 = (\VAR2.(case VAR2 in   left_C :  f
                                     ||right_C :  f0
                                     end ))
   in (VAR1 s)

in
let inleft Var1 = (inleft_C Var1)

in
let inright = inright_C

in
let sumor_rec f f0 s =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in   (inleft_C VAR3) :  (f VAR3)
                  ||inright_C :  f0
                  end ))
   in (VAR1 s)

in
let False_rec = (fail "Exception") 

in
let except = False_rec

in
let absurd_set = False_rec

in
let and_rec F = F

in
let eq_rec a h b = h

in
let eq_spec a b H' = (eq_rec a H' b)

in
let pred n =
 ((\f.\f0.
    let rec VAR1 = 
     (\VAR2.
       (case VAR2 in
          O_C :  f
        ||(S_C VAR3) :  ((\fi.\F.\y.(fi y (F y))) f0 VAR1 VAR3)
        end
       ))
      in (VAR1 n))
    O
   (\u.\v.u)
 )

in
let le_or_gt n =
 (nat_rec (\m.left)
    (\y.\H.\m.
      (nat_rec right (\y0.\H0.(sumbool_rec left right (H y0))) m))
   n
 )

in
let O_or_S n = (nat_rec inright (\y.\H.(inleft (exist y))) n)

in
let sumbool_rec H H0 H1 = (sumbool_rec H H0 H1)

in
let R_connected x y = R_connected_C

in
let Eq_connected x y = Eq_connected_C

in
let L_connected x y = L_connected_C

in
let connected_rec x y f f0 f1 c =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in
       R_connected_C :  f
     ||Eq_connected_C :  f0
     ||L_connected_C :  f1
     end
    ))
   in (VAR1 c)

in
let le_dec n =
 (nat_rec (\p.left)
    (\y.\H.\p.
      (nat_rec right (\y0.\H0.(sumbool_rec left right (H y0))) p))
   n
 )

in
let lne_dec n p = (sumbool_rec left right (le_dec (S n) p))

in
let le_or_lne n =
 (nat_rec (\p.left)
    (\y.\H.\p.
      (nat_rec right (\y0.\H0.(sumbool_rec left right (H y0))) p))
   n
 )

in
let lne_connected n p =
 (sumbool_rec
    (sumbool_rec (Eq_connected n p) (R_connected n p) (le_or_lne p n))
    (L_connected n p)
   (le_or_lne n p)
 )

in
let diff n =
 ((\f.\f0.
    let rec VAR4 = 
     (\VAR5.
       (case VAR5 in
          O_C :  f
        ||(S_C VAR6) :  ((\fi.\F.\y.(fi y (F y))) f0 VAR4 VAR6)
        end
       ))
      in (VAR4 n))
    (\m.O)
   (\p.\f.\m.
     ((\f0.\f1.
        let rec VAR1 = 
         (\VAR2.
           (case VAR2 in
              O_C :  f0
            ||(S_C VAR3) :  ((\fi.\F.\y.(fi y (F y))) f1 VAR1 VAR3)
            end
           ))
          in (VAR1 m))
        (S p)
       (\r.\s.(f r))
     ))
 )

in
let max n =
 ((\f.\f0.
    let rec VAR4 = 
     (\VAR5.
       (case VAR5 in
          O_C :  f
        ||(S_C VAR6) :  ((\fi.\F.\y.(fi y (F y))) f0 VAR4 VAR6)
        end
       ))
      in (VAR4 n))
    (\m.m)
   (\p.\f.\m.
     (S
       ((\f0.\f1.
          let rec VAR1 = 
           (\VAR2.
             (case VAR2 in
                O_C :  f0
              ||(S_C VAR3) :  ((\fi.\F.\y.(fi y (F y))) f1 VAR1 VAR3)
              end
             ))
            in (VAR1 m))
          p
         (\r.\s.(f r))
       )
     ))
 )

in
let wfi_lne1 n H =
 (nat_rec (\i.(H i (\p.False_rec)))
    (\y.\H0.\i.(sumbool_rec (H0 i) (H i (\p.(H0 p))) (le_dec i y)))
   n
 )

in
let wfi_lne n H = (wfi_lne1 n H n)

in
let A0 = A0_C

in
let A1 = A1_C

in
let M_rec f f0 m =
 let rec VAR1 = (\VAR2.(case VAR2 in   A0_C :  f
                                     ||A1_C :  f0
                                     end ))
   in (VAR1 m)

in
let lneM_rec p y y0 = p

in
let lneM_connected a =
 (M_rec (\b.(M_rec (Eq_connected A0 A0) (R_connected A0 A1) b))
    (\b.(M_rec (L_connected A1 A0) (Eq_connected A1 A1) b))
   a
 )

in
let wfi_lneM a H =
 (H a (M_rec (\c.except) (\c.(lneM_rec (H A0 (\c0.except)) c A1)) a))

in
let Emptyword = Emptyword_C

in
let Cons Var1 Var2 = (Cons_C Var1 Var2)

in
let word_rec f f0 w =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in
       Emptyword_C :  f
     ||(Cons_C VAR3 VAR4) : 
       ((\fi.\F.\y.\y0.(fi y y0 (F y0))) f0 VAR1 VAR3 VAR4)
     end
    ))
   in (VAR1 w)

in
let tail_ren l =
 ((\f.\f0.
    let rec VAR1 = 
     (\VAR2.
       (case VAR2 in
          Emptyword_C :  f
        ||(Cons_C VAR3 VAR4) : 
          ((\fi.\F.\y.\y0.(fi y y0 (F y0))) f0 VAR1 VAR3 VAR4)
        end
       ))
      in (VAR1 l))
    Emptyword
   (\a.\x.\y.x)
 )

in
let head_ren l =
 ((\f.\f0.
    let rec VAR1 = 
     (\VAR2.
       (case VAR2 in
          Emptyword_C :  f
        ||(Cons_C VAR3 VAR4) : 
          ((\fi.\F.\y.\y0.(fi y y0 (F y0))) f0 VAR1 VAR3 VAR4)
        end
       ))
      in (VAR1 l))
    A0
   (\a.\x.\b.a)
 )

in
let len x =
 ((\f.\f0.
    let rec VAR1 = 
     (\VAR2.
       (case VAR2 in
          Emptyword_C :  f
        ||(Cons_C VAR3 VAR4) : 
          ((\fi.\F.\y.\y0.(fi y y0 (F y0))) f0 VAR1 VAR3 VAR4)
        end
       ))
      in (VAR1 x))
    O
   (\a.\y.S)
 )

in
let slexn'_rec H H0 w =
 (word_rec (\w0.except)
    (\m.\y.\H1.\w0.
      (word_rec except
         (\m0.\y0.\H2.
           (connected_rec m m0 (H y y0 m m0)
              (eq_rec m (H0 y y0 m (H1 y0)) m0) except
             (lneM_connected m m0)
           ))
        w0
      ))
   w
 )

in
let slexn_connected x =
 (word_rec
    (\y.
      (word_rec (Eq_connected Emptyword Emptyword) (\m.\y0.\H.False_rec)
        y
      ))
    (\m.\y.\H.\y0.
      (word_rec False_rec
         (\m0.\y1.\H0.
           (connected_rec m m0 (R_connected (Cons m y) (Cons m0 y1))
              (eq_rec m
                 (connected_rec y y1
                    (R_connected (Cons m y) (Cons m y1))
                    (Eq_connected (Cons m y) (Cons m y1))
                    (L_connected (Cons m y) (Cons m y1))
                   (H y1)
                 )
                m0
              ) (L_connected (Cons m y) (Cons m0 y1))
             (lneM_connected m m0)
           ))
        y0
      ))
   x
 )

in
let lnew_rec x y =
 (connected_rec (len x) (len y) (\H.\H0.H0)
    (\H.\H0.(connected_rec x y H except except (slexn_connected x y)))
    (\H.\H0.except)
   (lne_connected (len x) (len y))
 )

in
let lnew_connected x y =
 (connected_rec (len x) (len y) (R_connected x y)
    (connected_rec x y (R_connected x y) (Eq_connected x y)
       (L_connected x y)
      (slexn_connected x y)
    ) (L_connected x y)
   (lne_connected (len x) (len y))
 )

in
let wfi_lnel1 x H =
 (word_rec (\t.(H t (\z.False_rec)))
    (\m.\y.\H0.\t.
      (sumbool_rec (H0 t) (H t (\z.(H0 z))) (le_dec (len t) (len y))))
   x
 )

in
let wfi_lnel x H = (wfi_lnel1 x H x)

in
let wfi_slexn n =
 (nat_rec
    (\H.\x.(word_rec (H Emptyword (\z.except)) (\m.\y.\H0.except) x))
    (\y.\H.\H0.\x.
      (word_rec except
         (\m.\y0.\H1.
           (wfi_lneM m
              (\b.\H3.\x0.
                (H
                   (\y1.\H5.
                     (H0 (Cons b y1)
                       (\z.
                         (slexn'_rec (\x1.\y2.\a.\b0.(H3 a x1))
                            (\x1.\y2.\a.\H9.(eq_rec b (H5 x1) a)) 
                            z
                           (Cons b y1)
                         ))
                     ))
                  x0
                ))
             y0
           ))
        x
      ))
   n
 )

in
let wfi_lnew x H =
 (wfi_lnel x
   (\y.\H0.
     (wfi_slexn (len y)
        (\y0.\H1.(H y0 (\z.(lnew_rec z y0 (H1 z) (H0 z)))))
       y
     ))
 )

in
let bad_intro Var1 Var2 Var3 = (bad_intro_C Var1 Var2 Var3)

in
let bad_rec f0 b =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in
       (bad_intro_C VAR3 VAR4 VAR5) :  (f0 VAR3 VAR4 VAR5)
     end
    ))
   in (VAR1 b)

in
let Mincex_intro n x p p1 p2 p3 p4 = (p4 p p1 p2 p3)

in
let Mincex_rec n x H H0 = (H0 H)

in
let bad_thick H H0 n H1 =
 (H (S n) (\x.\H2.(H0 n (S n) Emptyword x H1 H2)))

in
let switcher thick_h k k0 H H0 x =
 (word_rec (\H1.(thick_h (max k k0) H1))
    (\m.
      (M_rec (\y.\H1.\H2.(H (max k k0) y H2))
         (\y.\H1.\H2.(H0 (max k k0) y H2))
        m
      ))
   x
 )

in
let reader exi_imh thick_h k k0 H H0 =
 (exi_imh (max k k0) (\x.\H1.(switcher thick_h k k0 H H0 x H1)))

in
let little_inf_A0_or_inf_A1 exi_imh thick_h k H H0 =
 (H0 (\k0.\H1.(reader exi_imh thick_h k k0 H H1)))

in
let inf_A0_or_inf_A1 exi_imh thick_h H H0 =
 (H (\k.\H1.(little_inf_A0_or_inf_A1 exi_imh thick_h k H1 H0)))

in
let eqgn_trans n H H0 H1 i s t H3 H4 H5 =
 (H i (\x.\H6.(H0 i s x H3 H6 (H1 i x t H6 H4 H5))))

in
let eqgn_Minbadns H n H0 H1 p H3 =
 (H1 p
   (\y.\H4.\H5.
     (bad_rec
        (\e.\u.\c.
          (e p
            (\x.\H6.
              (H0 p y x H4 H6
                (H3 x H6
                  (\H8.\H9.\z.\H10.
                    (H5 H8
                       (eqgn_trans p e
                          (\i.\s.\t.\H13.\H14.\H15.
                            (H0 i s t H13 H14 H15))
                         H9
                       ) z
                      H10
                    ))
                )
              ))
          ))
       H
     ))
 )

in
let exi_cmin_S n H x =
 (wfi_lnew x
   (\y.\H0.\H1.\H2.\H3.
     (H y H1 H2 (\H4.\H5.\z.\H6.(H0 z H4 (eqgn_Minbadns H4 n H5 H2) H6))
       H3
     ))
 )

in
let exi_cmin_exi n H x H0 =
 (bad_rec
    (\e.\u.\c.\H1.\H2.\H3.
      (e (S n)
        (\x0.\H4.
          (H x0 H0
             (\p.\H6.
               (sumbool_rec (H1 p H6)
                  (H6 x (eq_rec n H3 p) (eq_rec n H2 p))
                 (lne_dec p n)
               ))
            H4
          ))
      ))
   H0
 )

in
let ExiMin1 x H H0 n =
 (nat_rec
    (\H1.
      (exi_cmin_S O (\x0.\H2.\H3.\H4.\H5.(H1 x0 (\H6.(H6 H2 H3 H5 H4))))
         x H (\p.\H3.False_rec)
        H0
      ))
    (\y.\H1.\H2.
      (H1
        (\x0.\H3.
          (H3
            (\H4.\H5.\H6.\H7.
              (exi_cmin_exi y
                 (\x1.\H8.\H9.\H10.
                   (exi_cmin_S (S y)
                      (\x2.\H11.\H12.\H13.\H14.
                        (H2 x2 (\H15.(H15 H11 H12 H14 H13))))
                      x1 H8 H9
                     H10
                   ))
                 x0 H4 H5 H7
                H6
              ))
          ))
      ))
   n
 )

in
let ExiMin Badf f0 f_0_f0 = (ExiMin1 f0 Badf f_0_f0)

in
let UniMin_eqgn n i H0 H1 H2 H3 H4 i0 s t H6 H7 H8 =
 (H4 i0 s t
    (Mincex_intro i0 s H0 (\p.\H10.(H2 p H10)) H6
      (\H9.\H10.\z.\H11.
        (H2 i0
          (\y.\H13.\H14.
            (bad_rec (\e.\u.\c.(u i0 s y H6 H13 (H14 H9 H10 z H11))) H0))
        ))
    )
    (Mincex_intro i0 t H1 (\p.\H10.(H3 p H10)) H7
      (\H9.\H10.\z.\H11.
        (H3 i0
          (\y.\H13.\H14.
            (bad_rec (\e.\u.\c.(u i0 t y H7 H13 (H14 H9 H10 z H11))) H1))
        ))
    )
   H8
 )

in
let UniMin1 n =
 (nat_rec (\i.\s.\t.\H0.\H1.\H2.False_rec)
    (\y.\H.\i.\s.\t.\H1.\H2.\H3.
      (sumbool_rec (H i s t H1 H2 H3)
         (H1
           (\H5.\H6.\H7.\H8.
             (H2
               (\H9.\H10.\H11.\H12.
                 (connected_rec s t
                    (H12 H5 (UniMin_eqgn y i H9 H5 H10 H6 H) s H7) 
                    H3 (H8 H9 (UniMin_eqgn y i H5 H9 H6 H10 H) t H11)
                   (lnew_connected s t)
                 ))
             ))
         )
        (lne_dec i y)
      ))
   n
 )

in
let UniMin n x y H H0 H1 = (UniMin1 (S n) n x y H H0 H1)

in
let CexMin i j x y H H0 =
 (H0
   (\H3.\H4.\H5.\H6.
     (bad_rec
        (\e.\u.\c.
          (H4 i
            (\y0.\H7.\H8.
              (UniMin i x y0 H
                 (Mincex_intro i y0 H3 (\p.\H10.(H4 p H10)) H7 H8)
                (c i j y0 y H7 H5)
              ))
          ))
       H3
     ))
 )

in
let BadMin Badf f0 f_0_f0 =
 (bad_intro (ExiMin Badf f0 f_0_f0) UniMin CexMin)

in
let Xa_intro a0 Var1 Var2 Var3 = (Xa_intro_C Var1 Var2 Var3)

in
let X'_intro a0 Var1 Var2 Var3 Var4 Var5 =
 (X'_intro_C Var1 Var2 Var3 Var4 Var5)

in
let Xn_rec a0 f0 f1 n n0 x =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in
       (Xa_intro_C VAR3 VAR4 VAR5) :  (f0 VAR3 VAR4 VAR5)
     ||(X'_intro_C VAR6 VAR7 VAR8 VAR9 VAR10) : 
       ((\fi.\F.\y.\y0.\y1.\y2.\y3.(fi y y0 y1 (F y1) y2 y3 (F y3))) f1
          VAR1 VAR6 VAR7 VAR8 VAR9
         VAR10
       )
     end
    ))
   in (VAR1 x)

in
let Leastp_intro p Var1 Var2 = (Leastp_intro_C Var1 Var2)

in
let Leastp_rec p f l =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in   (Leastp_intro_C VAR3 VAR4) :  (f VAR3 VAR4)
                  end ))
   in (VAR1 l)

in
let Xn_elim a0 y y0 H H0 H1 =
 (Xn_rec a0 H0 (\p.\n.\y1.\H2.\n'.\y2.\H3.(H1 p n H2 n' H3)) y y0 H)

in
let X'_elim a0 i q H_Xn =
 (eq_rec (pred (S i))
    (Xn_rec a0 (\n.\y.\f0.\H0.False_rec)
       (\p.\n.\y.\H.\n'.\y0.\H0.\H2.(H2 n' y0)) (S i) q
      H_Xn
    )
   i
 )

in
let Xa_elim a0 q H H0 =
 (Xn_elim a0 O q H (\n.\y.\H1.\H2.(H2 y H1)) (\p.\n.\H1.\n'.\H2.H1) H0)

in
let Xn_decreases1 a0 q p H =
 (Xn_rec a0 (\n.\y.\f0.(Xa_intro a0 n y f0))
    (\p0.\n.\y.\H0.\n'.\y0.\H1.y) (S p) q
   H
 )

in
let Xn_decreases a0 n q p =
 (nat_rec (\H0.(eq_rec O H0 n))
    (\y.\H.\H1.
      (sumbool_rec (H (Xn_decreases1 a0 q y H1)) (eq_rec (S y) H1 n)
        (le_dec n y)
      ))
   p
 )

in
let Xn_in_Xa a0 n p H = (Xn_decreases a0 O p n H)

in
let X1 a0 n =
 (nat_rec (\p.\q.\H0.\H1.(X'_intro a0 O q H1 p H0))
    (\y.\H.\p.\q.\H1.\H2.
      (X'_intro a0 (S y) q
         (H p q
            (Xn_rec a0 (\n0.\y0.\f0.(Xa_intro a0 n0 y0 f0))
               (\p0.\n0.\y0.\H3.\n'.\y1.\H4.y0) (S y) p
              H1
            )
           H2
         ) p
        H1
      ))
   n
 )

in
let Xn_non_empty a0 inf_many n =
 (nat_rec (\H.(inf_many O (\n0.\x.\H1.(H n0 (Xa_intro a0 n0 x H1)))))
    (\y.\H.\H0.
      (H
        (\p.\H1.
          (inf_many (S p)
            (\n0.\x.\H3.(H0 n0 (X1 a0 y p n0 H1 (Xa_intro a0 n0 x H3))))
          ))
      ))
   n
 )

in
let Exig a0 inf_many n H =
 (Xn_non_empty a0 inf_many n
   (\p.(wfi_lne p (\m.\H0.\H1.(H m (Leastp_intro m H1 H0)))))
 )

in
let Unig a0 n p q H H0 H1 =
 (Leastp_rec p
    (Leastp_rec q
       (\x.\a.\x0.\a00.
         (connected_rec p q (a p x0) H1 (a00 q x) (lne_connected p q)))
      H0
    )
   H
 )

in
let fxhd a0 n0 i x Var1 = (fxhd_C Var1)

in
let fxtl a0 n0 i x Var1 Var2 Var3 = (fxtl_C Var1 Var2 Var3)

in
let fx_rec a0 n0 i x f0 f1 f2 =
 let rec VAR1 = 
  (\VAR2.
    (case VAR2 in
       (fxhd_C VAR3) :  (f0 VAR3)
     ||(fxtl_C VAR4 VAR5 VAR6) :  (f1 VAR4 VAR5 VAR6)
     end
    ))
   in (VAR1 f2)

in
let Unifx Badf a0 n0 n x y H H0 H1 =
 (bad_rec
    (\e.\u.\c.
      (fx_rec a0 n0 n x
         (\f0.
           (fx_rec a0 n0 n y (\f1.(u n x y f0 f1 H1))
              (\p.\g0.\f1.except)
             H0
           ))
         (\p.\g0.\f0.
           (fx_rec a0 n0 n y (\f1.except)
              (\p0.\Hg.\Hf.
                (Unig a0 (diff n n0) p0 p Hg g0
                  (u p (Cons a0 x) (Cons a0 y) f0 (eq_rec p0 Hf p) H1)
                ))
             H0
           ))
        H
      ))
   Badf
 )

in
let Exifx Badf a0 inf_many n0 n H =
 (bad_rec
    (\e.\u.\c.
      (sumbool_rec
         (Exig a0 inf_many (diff n n0)
           (\p.\H1.
             (Leastp_rec p
                (\x.\a.
                  (Xn_elim a0 (diff n n0) p x
                     (\n1.\y.\H3.\H4.(H y (fxtl a0 n0 n y n1 H4 H3)))
                     (\p0.\n1.\H3.\n'.\H4.H3)
                    H1
                  ))
               H1
             ))
         ) (e n (\x.\H1.(H x (fxhd a0 n0 n x H1))))
        (le_or_lne n0 n)
      ))
   Badf
 )

in
let g_grows a0 i j p q H0 H1 =
 (Leastp_rec p
    (\x.\a.
      (X'_elim a0 i q
         (Xn_decreases a0 (S i) q j (Leastp_rec q (\x0.\a00.x0) H1))
        (\q'.\H3.(a q' H3))
      ))
   H0
 )

in
let g_grows_0 a0 n0 n0_min i p H =
 (Leastp_rec p
    (\x.\a.
      (Leastp_rec n0 (\x0.\a00.(a00 p (Xn_in_Xa a0 i p x))) n0_min))
   H
 )

in
let Cexfx Badf a0 n0 n0_min i j x y H H0 =
 (bad_rec
    (\e.\u.\c.
      (fx_rec a0 n0 i x
         (\f0.
           (fx_rec a0 n0 j y (\f1.(c i j x y f0 f1))
              (\p.\g0.\f1.
                (sumbool_rec (c i p x (Cons a0 y) f0 f1)
                   (g_grows_0 a0 n0 n0_min (diff j n0) p g0)
                  (le_or_lne n0 p)
                ))
             H0
           ))
         (\p.\g0.\f0.
           (fx_rec a0 n0 j y (\f1.except)
              (\p0.\g1.\f1.
                (sumbool_rec
                   (g_grows a0 (diff i n0) (diff j n0) p p0 g0 g1)
                   (c p p0 (Cons a0 x) (Cons a0 y) f0 f1)
                  (le_or_lne p0 p)
                ))
             H0
           ))
        H
      ))
   Badf
 )

in
let Badfx Badf a0 inf_many n0 n0_min =
 (bad_intro (Exifx Badf a0 inf_many n0) (Unifx Badf a0 n0)
   (Cexfx Badf a0 n0 n0_min)
 )

in
let eqgn_f_fx Badf a0 n0 i s t H0 H1 H2 =
 (fx_rec a0 n0 i t (\f0.(bad_rec (\e.\u.\c.(u i s t H0 f0 H2)) Badf))
    (\p.\g0.\f0.except)
   H1
 )

in
let eqgn_fxMin_h Badf f0 f_0_f0 a n H H0 i s t H2 H3 H4 =
 (H0 i
   (\y.
     (bad_rec
        (\e.\u.\c.\H5.\H6.
          (u i s y H2 H5
            (eqgn_f_fx (BadMin Badf f0 f_0_f0) a n i y t
               (Mincex_intro i y H (\p.\H9.(H0 p H9)) H5 H6) H3
              (eq_rec s H4 y)
            )
          ))
       H
     ))
 )

in
let snake Badf f0 f_0_f0 a H n0 H0 H1 =
 (Xa_elim a n0 H1
   (\y.\H3.
     (H3
       (\H5.\H6.\H7.\H8.
         (H8
            (Badfx (BadMin Badf f0 f_0_f0) a H n0
              (Leastp_intro n0 H1 H0)
            ) (eqgn_fxMin_h Badf f0 f_0_f0 a n0 H5 H6) y
           (fxtl a n0 n0 y n0
              (eq_rec O (Leastp_intro n0 H1 H0) (diff n0 n0))
             H3
           )
         ))
     ))
 )

in
let holf Badf f0 f_0_f0 a H n x H1 =
 (wfi_lne n (snake Badf f0 f_0_f0 a H) (Xa_intro a n x H1))

in
let one_letter_final Badf f0 f_0_f0 a H =
 (H O (holf Badf f0 f_0_f0 a H))

in
let final Badf f0 f_0_f0 =
 (bad_rec
    (\e.\u.\c.
      (inf_A0_or_inf_A1 e (bad_thick e c)
         (\H.(one_letter_final Badf f0 f_0_f0 A0 H))
        (\H.(one_letter_final Badf f0 f_0_f0 A1 H))
      ))
   (BadMin Badf f0 f_0_f0)
 )

in
let f_intro f0 n = f_intro_C

in
let f_rec f0 n f1 w f2 =
 let rec VAR1 = (\VAR2.(case VAR2 in   f_intro_C :  f1
                                     end ))
   in (VAR1 f2)

in
let A_intro f0 Var1 Var2 = (A_intro_C Var1 Var2)

in
let A_rec f0 f a =
 let rec VAR1 = 
  (\VAR2.(case VAR2 in   (A_intro_C VAR3 VAR4) :  (f VAR3 VAR4)
                       end ))
   in (VAR1 a)

in
let Exif f0 n H = (H (f0 n) (f_intro f0 n))

in
let Unif f0 n x y H_f_x H_f_y H_eq_x_y = H_eq_x_y

in
let Cexf f0 i j x y H H0 =
 (f_rec f0 i (f_rec f0 j (A_intro f0 i j) y H0) x H)

in
let Badf f0 = (bad_intro (Exif f0) (Unif f0) (Cexf f0))

in
let Higman f0 = (final (Badf f0) (f0 O) (f_intro f0 O))

in
let rec nat_to_num O_C = 0
     || nat_to_num (S_C x) = 1 + (nat_to_num x)

in
let trad (A_intro_C x y) = (nat_to_num x,nat_to_num y)

in
let rec string_to_word l =
  (case l in
     [] : Emptyword
 ||  true.rest : Cons A0 (string_to_word rest)
 ||  false.rest : Cons A1 (string_to_word rest)
   end)

in
let input_ln = choplist (splitat '\n') input

in
let l =
 map (string_to_word o (map (= '0')) o (filter (\x.(x='0' | x='1')))) input_ln

in
let f n = select ((nat_to_num n)+1) l

in
let (n1,n2) = trad (Higman f)

in
seq n1 "The result is "@itos n1@" and "@itos n2@"\n"

