(*****************************************************************************)
(*          Projet Formel - Calculus of Inductive Constructions V5.8         *)
(*****************************************************************************)
(*                                                                           *)
(*                      HEAPSORT for lists (proof)                           *)
(*                                                                           *)
(*****************************************************************************)
(*                                                                           *)
(*                           Benjamin WERNER                                 *)
(*                                                                           *)
(*****************************************************************************)

Require Heap_def.

(*****************)
(* specification *)
(*****************)

Theorem heapsort : (l:list){m:list|(sort m)&(eq_fun (list_content l) (list_content m))}.
Goal.
Intros.
Elim (list_to_heap l).
Intros.
Elim (heap_to_list T i).
Intros.
Exists l0;Auto.
Unfold eq_fun;Intro.
Apply trans_equal with (content T a).
Exact (e a).
Exact (e0 a).
Save.

Provide Heap_proof.
